# Windows compile and link csamp.exe  (IBM C/C++ 3.5)
#
# Note: Paths may be different on your machine

PLATFORM  = WINNT

BUILDDIR  = e:\cblythe\test
BASEDIR   = e:\Progra~1\Vast5-13CLI
IBMCPPDIR = d:\ibmcppw
CALLINDIR = $(BASEDIR)\callin

LIBS     = $(CALLINDIR)\abtvxt40.lib $(IBMCPPDIR)\LIB\cppwm35.lib \
           $(IBMCPPDIR)\LIB\kernel32.lib $(IBMCPPDIR)\SDK\LIB\user32.lib \
           $(IBMCPPDIR)\SDK\LIB\gdi32.lib
HEADERS  = $(CALLINDIR)\ioarea.h $(CALLINDIR)\abtvxt40.h
SRCSAMP  = $(CALLINDIR)\csamp.c
OBJSAMP  = $(BUILDDIR)\csamp.obj
EXESAMP  = $(BUILDDIR)\csamp.exe

CC       = ICC
LINK     = ILINK	

# CFLAGS:		Compile Flags
#
#	/Fo		Generate the object file
#	/I		Specify where to search for include files
#	/Ge+		Use the version of the runtime library to build executable
#	/Gd+		Use the dynamically linked version of the rutnime library
#	/C+		Perform compile only
#	/D		Define preprocessor macros
CFLAGS = /I$(CALLINDIR) /C+ /DABT_SYSTEM /DABT_WIN32 /Fo$@ /Ge+ /Gd+ 
            
# LFLAGS:              	Linker flags
#	
#	/EXEC		Build executalbe
#	/NOD		No default library search
#	/O		Specifies the output filename
LFLAGS = /EXEC /NOD /O:$@

all: $(EXESAMP)

clean:
   - del $(EXESAMP) $(OBJSAMP)

$(EXESAMP): $(OBJSAMP)
   $(LINK) $(OBJSAMP) $(LIBS) $(LFLAGS)

$(OBJSAMP): $(SRCSAMP) $(HEADERS) 
   $(CC) $(CFLAGS) $(SRCSAMP)